#
# This file was generated using xslt from its XML file
#
# Copyright 2009, Associated Universities Inc., Washington DC
#
import sys
import os
from  casac import *
import string
from taskinit import casalog
#from taskmanager import tm
import task_sdlist
def sdlist(infile='', antenna=0, outfile='', overwrite=False):

        """list summary of single dish data
------------------
Keyword arguments
------------------
infile -- name of input SD dataset
        default: none - must input file name
        example: 'mysd.asap'
        See sdcal for allowed formats.
antenna -- select an antenna name or id (only effective for MS input)
        default: 0
        example: 'PM03'
        NOTE this parameter is effective only for MS input
outfile -- name of output file for summary list
        default: '' (no output file)
        example: 'mysd_summary.txt'
overwrite -- overwrite the output file if already exists
        options: (bool) True,False
        default: False

-----------
DESCRIPTION
-----------
Task sdlist lists the scan summary of the dataset after importing
as a scantable into ASAP.  It will optionally output this summary
as file.

-------
WARNING
-------
For the GBT raw SDFITS format data as input:
SDtasks are able to handle GBT raw SDFITS format data since the 
data filler is available. However, the functionality is not well 
tested yet, so that there may be unknown bugs.  

  
        """

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['infile'] = infile
        mytmp['antenna'] = antenna
        mytmp['outfile'] = outfile
        mytmp['overwrite'] = overwrite
	pathname='file:///'+os.environ.get('CASAPATH').split()[0]+'/xml/'
        trec = casac.utils().torecord(pathname+'sdlist.xml')

        casalog.origin('sdlist')
        if trec.has_key('sdlist') and casac.utils().verify(mytmp, trec['sdlist']) :
	    result = task_sdlist.sdlist(infile, antenna, outfile, overwrite)

	else :
	  result = False
        return result
